| Fast DDS Version 3.3.0 Fast DDS

Loading...
Searching...
No Matches
SharedMemTransportDescriptor Struct Reference
eProsima Fast DDS API Reference » RTPS » Common Module. » Transport Module.

Shared memory transport configuration. More...

`#include <SharedMemTransportDescriptor.hpp>`

Inheritance diagram for SharedMemTransportDescriptor:
[legend]

## Public Member Functions

virtual | ~SharedMemTransportDescriptor ()=default
| Destructor.
virtual TransportInterface * | create_transport () const override
| Factory method pattern.
uint32_t | min_send_buffer_size () const override
| Minimum size of the send buffer.
FASTDDS_EXPORTED_API | SharedMemTransportDescriptor ()
| Constructor.
FASTDDS_EXPORTED_API | SharedMemTransportDescriptor (const SharedMemTransportDescriptor &t)=default
| Copy constructor.
FASTDDS_EXPORTED_API SharedMemTransportDescriptor & | operator= (const SharedMemTransportDescriptor &t)=default
| Copy assignment.
FASTDDS_EXPORTED_API uint32_t | segment_size () const
| Return the size of the shared memory segment.
FASTDDS_EXPORTED_API void | segment_size (uint32_t segment_size)
| Set the size of the shared memory segment.
virtual uint32_t | max_message_size () const override
| Return the maximum size of a single message in the transport (in octets).
FASTDDS_EXPORTED_API void | max_message_size (uint32_t max_message_size)
| Set the maximum size of a single message in the transport (in octets).
FASTDDS_EXPORTED_API uint32_t | port_queue_capacity () const
| Return the size of the listening port (in messages).
FASTDDS_EXPORTED_API void | port_queue_capacity (uint32_t port_queue_capacity)
| Set the size of the listening port (in messages).
FASTDDS_EXPORTED_API uint32_t | healthy_check_timeout_ms () const
| Return the timeout for the health check of ports (ms).
FASTDDS_EXPORTED_API void | healthy_check_timeout_ms (uint32_t healthy_check_timeout_ms)
| Set the timeout for the health check of ports (ms).
FASTDDS_EXPORTED_API std::string | rtps_dump_file () const
| Return the full path of the protocol dump file.
FASTDDS_EXPORTED_API void | rtps_dump_file (const std::string &rtps_dump_file)
| Set the full path of the protocol dump file.
FASTDDS_EXPORTED_API ThreadSettings | dump_thread () const
| Return the thread settings for the transport dump thread.
FASTDDS_EXPORTED_API void | dump_thread (const ThreadSettings &dump_thread)
| Set the thread settings for the transport dump thread.
FASTDDS_EXPORTED_API bool | operator== (const SharedMemTransportDescriptor &t) const
| Comparison operator.
Public Member Functions inherited from PortBasedTransportDescriptor
FASTDDS_EXPORTED_API | PortBasedTransportDescriptor (uint32_t maximumMessageSize, uint32_t maximumInitialPeersRange)
| Constructor.
FASTDDS_EXPORTED_API | PortBasedTransportDescriptor (const PortBasedTransportDescriptor &t)=default
| Copy constructor.
FASTDDS_EXPORTED_API PortBasedTransportDescriptor & | operator= (const PortBasedTransportDescriptor &t)=default
| Copy assignment.
virtual FASTDDS_EXPORTED_API | ~PortBasedTransportDescriptor ()=default
| Destructor.
bool FASTDDS_EXPORTED_API | operator== (const PortBasedTransportDescriptor &t) const
| Comparison operator.
virtual FASTDDS_EXPORTED_API const ThreadSettings & | get_thread_config_for_port (uint32_t port) const
| Get the ThreadSettings for a specific port.
virtual FASTDDS_EXPORTED_API bool | set_thread_config_for_port (const uint32_t &port, const ThreadSettings &thread_settings)
FASTDDS_EXPORTED_API const ThreadSettings & | default_reception_threads () const
| Returns the ThreadSettings for the default reception threads.
virtual FASTDDS_EXPORTED_API void | default_reception_threads (const ThreadSettings &default_reception_threads)
| Set the ThreadSettings for the default reception threads.
FASTDDS_EXPORTED_API const ReceptionThreadsConfigMap & | reception_threads () const
| Returns the ThreadSettings for the user-configured reception threads.
virtual FASTDDS_EXPORTED_API bool | reception_threads (const ReceptionThreadsConfigMap &reception_threads)
| Set the ThreadSettings for the user-configured reception threads.
Public Member Functions inherited from TransportDescriptorInterface
FASTDDS_EXPORTED_API | TransportDescriptorInterface (uint32_t maximumMessageSize, uint32_t maximumInitialPeersRange)
| Constructor.
FASTDDS_EXPORTED_API | TransportDescriptorInterface (const TransportDescriptorInterface &t)
| Copy constructor.
FASTDDS_EXPORTED_API TransportDescriptorInterface & | operator= (const TransportDescriptorInterface &t)
| Copy assignment.
virtual FASTDDS_EXPORTED_API | ~TransportDescriptorInterface ()=default
| Destructor.
virtual FASTDDS_EXPORTED_API uint32_t | max_initial_peers_range () const
| Returns the maximum number of opened channels for each initial remote peer (maximum number of guessed initial peers to try to connect).
FASTDDS_EXPORTED_API bool | operator== (const TransportDescriptorInterface &t) const
| Comparison operator.
FASTDDS_EXPORTED_API void | lock ()
| Lock internal mutex (for Fast-DDS internal use).
FASTDDS_EXPORTED_API void | unlock ()
| Unlock internal mutex (for Fast-DDS internal use).

## Static Public Attributes

static constexpr uint32_t | shm_default_segment_size = 0
static constexpr uint32_t | shm_default_port_queue_capacity = 512
static constexpr uint32_t | shm_default_healthy_check_timeout_ms = 1000
static constexpr uint32_t | shm_implicit_segment_size = 512 * 1024

## Additional Inherited Members

Public Types inherited from PortBasedTransportDescriptor
using | ReceptionThreadsConfigMap = std::map<uint32_t, ThreadSettings>
Public Attributes inherited from TransportDescriptorInterface
uint32_t | maxMessageSize
| Maximum size of a single message in the transport.
uint32_t | maxInitialPeersRange
| Number of channels opened with each initial remote peer.
Protected Attributes inherited from PortBasedTransportDescriptor
ThreadSettings | default_reception_threads_
| Thread settings for the default reception threads.
ReceptionThreadsConfigMap | reception_threads_
| Thread settings for the specific reception threads, indexed by port.

## Detailed Description

Shared memory transport configuration.

The kind is given by eprosima::fastdds::rtps::LOCATOR_KIND_SHM.

- segment_size_: size of the shared memory segment (in octets).
- port_queue_capacity_: size of the listening port (in messages).
- healthy_check_timeout_ms_: timeout for the health check of ports (ms).
- rtps_dump_file_: full path of the protocol dump file.

## Constructor & Destructor Documentation

## ◆ ~SharedMemTransportDescriptor()

virtual ~SharedMemTransportDescriptor | ( |  | ) |

virtual default

Destructor.

## ◆ SharedMemTransportDescriptor() [1/2]

FASTDDS_EXPORTED_API SharedMemTransportDescriptor | ( |  | ) |

Constructor.

## ◆ SharedMemTransportDescriptor() [2/2]

FASTDDS_EXPORTED_API SharedMemTransportDescriptor | ( | const SharedMemTransportDescriptor & | t | ) |

default

Copy constructor.

## Member Function Documentation

## ◆ create_transport()

virtual TransportInterface * create_transport | ( |  | ) | const

override virtual

Factory method pattern.

It will create and return a TransportInterface corresponding to this descriptor. This provides an interface to the NetworkFactory to create the transports without the need to know about their type

Implements TransportDescriptorInterface.

Reimplemented in test_SharedMemTransportDescriptor.

## ◆ dump_thread() [1/2]

FASTDDS_EXPORTED_API ThreadSettings dump_thread | ( |  | ) | const

inline

Return the thread settings for the transport dump thread.

## ◆ dump_thread() [2/2]

FASTDDS_EXPORTED_API void dump_thread | ( | const ThreadSettings & | dump_thread | ) |

inline

Set the thread settings for the transport dump thread.

## ◆ healthy_check_timeout_ms() [1/2]

FASTDDS_EXPORTED_API uint32_t healthy_check_timeout_ms | ( |  | ) | const

inline

Return the timeout for the health check of ports (ms).

## ◆ healthy_check_timeout_ms() [2/2]

FASTDDS_EXPORTED_API void healthy_check_timeout_ms | ( | uint32_t | healthy_check_timeout_ms | ) |

inline

Set the timeout for the health check of ports (ms).

## ◆ max_message_size() [1/2]

virtual uint32_t max_message_size | ( |  | ) | const

inline override virtual

Return the maximum size of a single message in the transport (in octets).

Reimplemented from TransportDescriptorInterface.

## ◆ max_message_size() [2/2]

FASTDDS_EXPORTED_API void max_message_size | ( | uint32_t | max_message_size | ) |

inline

Set the maximum size of a single message in the transport (in octets).

## ◆ min_send_buffer_size()

uint32_t min_send_buffer_size | ( |  | ) | const

inline override virtual

Minimum size of the send buffer.

Implements TransportDescriptorInterface.

## ◆ operator=()

FASTDDS_EXPORTED_API SharedMemTransportDescriptor & operator= | ( | const SharedMemTransportDescriptor & | t | ) |

default

Copy assignment.

## ◆ operator==()

FASTDDS_EXPORTED_API bool operator== | ( | const SharedMemTransportDescriptor & | t | ) | const

Comparison operator.

## ◆ port_queue_capacity() [1/2]

FASTDDS_EXPORTED_API uint32_t port_queue_capacity | ( |  | ) | const

inline

Return the size of the listening port (in messages).

## ◆ port_queue_capacity() [2/2]

FASTDDS_EXPORTED_API void port_queue_capacity | ( | uint32_t | port_queue_capacity | ) |

inline

Set the size of the listening port (in messages).

## ◆ rtps_dump_file() [1/2]

FASTDDS_EXPORTED_API std::string rtps_dump_file | ( |  | ) | const

inline

Return the full path of the protocol dump file.

## ◆ rtps_dump_file() [2/2]

FASTDDS_EXPORTED_API void rtps_dump_file | ( | const std::string & | rtps_dump_file | ) |

inline

Set the full path of the protocol dump file.

## ◆ segment_size() [1/2]

FASTDDS_EXPORTED_API uint32_t segment_size | ( |  | ) | const

inline

Return the size of the shared memory segment.

## ◆ segment_size() [2/2]

FASTDDS_EXPORTED_API void segment_size | ( | uint32_t | segment_size | ) |

inline

Set the size of the shared memory segment.

## Member Data Documentation

## ◆ shm_default_healthy_check_timeout_ms

uint32_t shm_default_healthy_check_timeout_ms = 1000

static constexpr

## ◆ shm_default_port_queue_capacity

uint32_t shm_default_port_queue_capacity = 512

static constexpr

## ◆ shm_default_segment_size

uint32_t shm_default_segment_size = 0

static constexpr

## ◆ shm_implicit_segment_size

uint32_t shm_implicit_segment_size = 512 * 1024

static constexpr

The documentation for this struct was generated from the following file:

- include/fastdds/rtps/transport/shared_mem/SharedMemTransportDescriptor.hpp